---
title: AudioContext
slug: Web/API/AudioContext
tags:
  - API
  - Audio
  - AudioContext
  - Interface
  - Reference
  - Web Audio API
  - sound
---
<div>{{APIRef("Web Audio API")}}</div>

<p><span class="seoSummary">The <code>AudioContext</code> interface represents an audio-processing graph built from audio modules linked together, each represented by an {{domxref("AudioNode")}}.</span> An audio context controls both the creation of the nodes it contains and the execution of the audio processing, or decoding. You need to create an <code>AudioContext</code> before you do anything else, as everything happens inside a context. It's recommended to create one AudioContext and reuse it instead of initializing a new one each time, and it's OK to use a single <code>AudioContext</code> for several different audio source and pipeline concurrently.</p>

<p>{{InheritanceDiagram}}</p>

<h2 id="Constructor">Constructor</h2>

<dl>
 <dt>{{domxref("AudioContext.AudioContext", "AudioContext()")}}</dt>
 <dd>Creates and returns a new <code>AudioContext</code> object.</dd>
</dl>

<h2 id="Properties">Properties</h2>

<p><em>Also inherits properties from its parent interface, {{domxref("BaseAudioContext")}}.</em></p>

<dl>
 <dt>{{domxref("AudioContext.baseLatency")}} {{readonlyinline}} {{experimental_inline}}</dt>
 <dd>Returns the number of seconds of processing latency incurred by the {{domxref("AudioContext")}} passing the audio from the {{domxref("AudioDestinationNode")}} to the audio subsystem.</dd>
 <dt>{{domxref("AudioContext.outputLatency")}} {{readonlyinline}} {{experimental_inline}}</dt>
 <dd>Returns an estimation of the output latency of the current audio context.</dd>
</dl>

<h2 id="Methods">Methods</h2>

<p><em>Also inherits methods from its parent interface, {{domxref("BaseAudioContext")}}.</em></p>

<dl>
 <dt>{{domxref("AudioContext.close()")}}</dt>
 <dd>Closes the audio context, releasing any system audio resources that it uses.</dd>
 <dt>{{domxref("AudioContext.createMediaElementSource()")}}</dt>
 <dd>Creates a {{domxref("MediaElementAudioSourceNode")}} associated with an {{domxref("HTMLMediaElement")}}. This can be used to play and manipulate audio from {{HTMLElement("video")}} or {{HTMLElement("audio")}} elements.</dd>
 <dt>{{domxref("AudioContext.createMediaStreamSource()")}}</dt>
 <dd>Creates a {{domxref("MediaStreamAudioSourceNode")}} associated with a {{domxref("MediaStream")}} representing an audio stream which may come from the local computer microphone or other sources.</dd>
 <dt>{{domxref("AudioContext.createMediaStreamDestination()")}}</dt>
 <dd>Creates a {{domxref("MediaStreamAudioDestinationNode")}} associated with a {{domxref("MediaStream")}} representing an audio stream which may be stored in a local file or sent to another computer.</dd>
 <dt>{{domxref("AudioContext.createMediaStreamTrackSource()")}}</dt>
 <dd>Creates a {{domxref("MediaStreamTrackAudioSourceNode")}} associated with a {{domxref("MediaStream")}} representing an media stream track.</dd>
 <dt>{{domxref("AudioContext.getOutputTimestamp()")}}</dt>
 <dd>Returns a new <code>AudioTimestamp</code> object containing two audio timestamp values relating to the current audio context.</dd>
 <dt>{{domxref("AudioContext.resume()")}}</dt>
 <dd>Resumes the progression of time in an audio context that has previously been suspended/paused.</dd>
 <dt>{{domxref("AudioContext.suspend()")}}</dt>
 <dd>Suspends the progression of time in the audio context, temporarily halting audio hardware access and reducing CPU/battery usage in the process.</dd>
</dl>

<h2 id="Examples">Examples</h2>

<p>Basic audio context declaration:</p>

<pre class="brush: js notranslate">var audioCtx = new AudioContext();</pre>

<p>Cross browser variant:</p>

<pre class="brush: js notranslate">var AudioContext = window.AudioContext || window.webkitAudioContext;
var audioCtx = new AudioContext();

var oscillatorNode = audioCtx.createOscillator();
var gainNode = audioCtx.createGain();
var finish = audioCtx.destination;
// etc.</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('Web Audio API', '#AudioContext', 'AudioContext')}}</td>
   <td>{{Spec2('Web Audio API')}}</td>
   <td></td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<div>

<p>{{Compat("api.AudioContext")}}</p>
</div>

<h2 id="See_also">See also</h2>

<ul style="margin-left: 40px;">
 <li><a href="/en-US/docs/Web_Audio_API/Using_Web_Audio_API">Using the Web Audio API</a></li>
 <li>{{domxref("OfflineAudioContext")}}</li>
</ul>
